#include <math.h>
#include <Sound.h>
#include <SoundComponents.h>
#include "SoundFileHeader.h"
#include "DBPlay.h"
#include "Dialog.h"
#include "Menu.h"
#include "Main.h"
#include "Law.h"
#include "ADPCMDVI.h"
#include "ALaw.h"

#ifdef powerc
extern SndDoubleBackUPP	gDoubleBackProc;
extern SndDoubleBackUPP	gSw16DoubleBackProc;
extern SndDoubleBackUPP	gS8DoubleBackProc;
extern SndDoubleBackUPP	gADoubleBackProc;
extern SndDoubleBackUPP	gMuDoubleBackProc;
extern SndDoubleBackUPP	gADDVIDoubleBackProc;
extern SndDoubleBackUPP	gFltDoubleBackProc;
#endif


/* Globals */
extern GlowBalls	global;


//extern ControlHandle	gSliderCntl;
extern MenuHandle		gFileMenu;
DoubleBufPlayInfo		gDBPI;


/* Based on the example in Inside Macintosh VI */
short
StartDBPlay(SoundInfo *mySI, double time)
{	
	short		i;
	unsigned long	startPos, tick;
	OSErr	error;
	
	global.playActive = TRUE;
	if(mySI->packMode == SF_FORMAT_TEXT 
		|| mySI->packMode == SF_FORMAT_32_LINEAR || mySI->packMode == SF_FORMAT_24_LINEAR
		|| mySI->packMode == SF_FORMAT_SPECT_AMP || mySI->packMode == SF_FORMAT_SPECT_AMPPHS
		|| mySI->packMode == SF_FORMAT_SPECT_AMPFRQ || mySI->packMode == SF_FORMAT_SPECT_MQ)
	{
		Delay(120,&tick);
		return(-1);
	}
	// save the file position to restore it later.
	gDBPI.timeDivisor = (float)(mySI->numBytes/(mySI->frameSize * mySI->sRate * mySI->nChans));

	gDBPI.dFileNum = mySI->dFileNum;
	GetFPos(gDBPI.dFileNum, &(gDBPI.filePos));
	
	gDBPI.numFrames = gDBPI.sizeBlock/mySI->nChans;
	gDBPI.numBytes = (long)(gDBPI.sizeBlock*mySI->frameSize);
	gDBPI.lastBlock = gDBPI.nextBlock = FALSE;
	
	// the grossest boundary would be 16-bits by two channels (4-bytes)
	startPos = (long)(time * mySI->frameSize * mySI->sRate * mySI->nChans);
	startPos = mySI->dataStart + ((startPos/4) * 4);

	gDBPI.doubleHeader.dbhNumChannels = mySI->nChans;
	switch(mySI->packMode)
	{
		case SF_FORMAT_4_ADDVI:
			gDBPI.doubleHeader.dbhSampleSize = 16L;
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gADDVIDoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)ADDVIDoubleBackProc;
#endif
			break;
		case SF_FORMAT_8_UNSIGNED:
			gDBPI.doubleHeader.dbhSampleSize = (long)(mySI->frameSize * 8);
			gDBPI.doubleHeader.dbhFormat = kOffsetBinary;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gDoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)DoubleBackProc;
#endif
			break;
		case SF_FORMAT_8_LINEAR:
			gDBPI.doubleHeader.dbhSampleSize = (long)(mySI->frameSize * 8);
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gS8DoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)S8DoubleBackProc;
#endif
			break;
		case SF_FORMAT_8_MULAW:
			gDBPI.doubleHeader.dbhSampleSize = 16L;
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gMuDoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)MuDoubleBackProc;
#endif
			break;
		case SF_FORMAT_8_ALAW:
			gDBPI.doubleHeader.dbhSampleSize = 16L;
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gADoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)ADoubleBackProc;
#endif
			break;
		case SF_FORMAT_16_SWAP:
			gDBPI.doubleHeader.dbhSampleSize = (long)(mySI->frameSize * 8);
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gSw16DoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)Sw16DoubleBackProc;
#endif
			break;
		case SF_FORMAT_16_LINEAR:
		case SF_FORMAT_24_LINEAR:
		case SF_FORMAT_32_LINEAR:
			gDBPI.doubleHeader.dbhSampleSize = (long)(mySI->frameSize * 8);
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gDoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)DoubleBackProc;
#endif
			break;
		case SF_FORMAT_32_FLOAT:
			gDBPI.doubleHeader.dbhSampleSize = 16L;
			gDBPI.doubleHeader.dbhFormat = kTwosComplement;
#ifdef powerc
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)gFltDoubleBackProc;
#else
			gDBPI.doubleHeader.dbhDoubleBack = (SndDoubleBackUPP)FltDoubleBackProc;
#endif
			break;
	}
    gDBPI.doubleHeader.dbhCompressionID = 0;
    gDBPI.doubleHeader.dbhPacketSize = 0;
    gDBPI.doubleHeader.dbhSampleRate = (unsigned long)(mySI->sRate * 65536);
	
	/* parameter block stuff for fast file routines */
	gDBPI.inSParmBlk = (ParmBlkPtr) NewPtrClear(sizeof(ParamBlockRec));;
	
	gDBPI.inSParmBlk->ioParam.ioCompletion = nil;
	gDBPI.inSParmBlk->ioParam.ioRefNum = mySI->dFileNum;
	gDBPI.inSParmBlk->ioParam.ioReqCount = (long)(gDBPI.sizeBlock * mySI->frameSize);
	gDBPI.inSParmBlk->ioParam.ioPosMode = fsFromStart;
	gDBPI.inSParmBlk->ioParam.ioPosOffset = startPos;
	gDBPI.inSParmBlk->ioParam.ioBuffer = gDBPI.fileBlock;
	
	/* Read First Buffer */
	error = PBRead(gDBPI.inSParmBlk, FALSE);
	
    /* Set up memory for double buffer */
	for (i = 0; i <= 1; ++i)
	{
		gDBPI.doubleHeader.dbhBufferPtr[i]->dbNumFrames = 0;
		gDBPI.doubleHeader.dbhBufferPtr[i]->dbFlags = 0;
		gDBPI.doubleHeader.dbhBufferPtr[i]->dbUserInfo[0] = SetCurrentA5();
		gDBPI.doubleHeader.dbhBufferPtr[i]->dbUserInfo[1] = (long)mySI;
		
		if(mySI->packMode ==  SF_FORMAT_8_LINEAR)
			S8DoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		else if(mySI->packMode == SF_FORMAT_4_ADDVI)
			ADDVIDoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		else if(mySI->packMode == SF_FORMAT_8_MULAW)
			MuDoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		else if(mySI->packMode == SF_FORMAT_8_ALAW)
			ADoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		else if(mySI->packMode == SF_FORMAT_16_SWAP)
			Sw16DoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		else if(mySI->packMode == SF_FORMAT_32_FLOAT)
			FltDoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		else
			DoubleBackProc(gDBPI.channel, gDBPI.doubleHeader.dbhBufferPtr[i]);
		while(gDBPI.inSParmBlk->ioParam.ioResult == 1);
	}
	gDBPI.ticksStart = TickCount() - (long)(time * 60);
	SndPlayDoubleBuffer(gDBPI.channel, (SndDoubleBufferHeaderPtr)&gDBPI.doubleHeader);
	return(1);
}

// wait: wait for the end of the currently playing file?
// open: is the file open or not? use the gui if it is.
void
StopDBPlay(void)
{
	SCStatus	status;
	SndCommand	command;
	OSErr		iErr;
		
	global.playActive = FALSE;

	command.cmd = quietCmd;
	command.param1 = 0;
	command.param2 = 0;
	iErr = SndDoImmediate(gDBPI.channel,&command);
	
	gDBPI.lastBlock = TRUE;
	do
	{
		SndChannelStatus(gDBPI.channel, sizeof (status), &status);
	}while (status.scChannelBusy);
	
	SetFPos(gDBPI.dFileNum, fsFromStart, gDBPI.filePos);	
}

pascal void
DoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);

	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}
	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	BlockMoveData (&(gDBPI.fileBlock[0]),&(doubleBuffer->dbSoundData[0]),gDBPI.inSParmBlk->ioParam.ioActCount);
	doubleBuffer->dbNumFrames = gDBPI.inSParmBlk->ioParam.ioActCount/(long)(localSI->frameSize*localSI->nChans);
	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount)||gDBPI.nextBlock)
	{
			doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
			gDBPI.lastBlock = TRUE;
	}
	else if(gDBPI.lastBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	}
	else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}

// this one will swap 16 bit Intel order files.
pascal void
Sw16DoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);
	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}

	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	Sw16BlockMove (&(gDBPI.fileBlock[0]),(Ptr)&(doubleBuffer->dbSoundData[0]),gDBPI.inSParmBlk->ioParam.ioActCount);
	doubleBuffer->dbNumFrames = gDBPI.inSParmBlk->ioParam.ioActCount/(long)(localSI->frameSize*localSI->nChans);
	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;

	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount)||gDBPI.nextBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
		gDBPI.lastBlock = TRUE;
	}else if(gDBPI.lastBlock)
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}

void
Sw16BlockMove(Ptr inBlock, Ptr outBlock, long size)
{
	long	i;
	for (i = 0; i < size; i += 2)
		* (short *)(outBlock + i) = (* (unsigned short *)(inBlock + i) << 8) + (* (unsigned short *)(inBlock + i) >> 8);
}

// my assumption is that signed 16 and unsigned 8 will play back ok everywhere.
pascal void
S8DoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);

	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	BlockMoveData(&(gDBPI.fileBlock[0]),&(doubleBuffer->dbSoundData[0]),gDBPI.inSParmBlk->ioParam.ioActCount);
 	SignToUnsignBlock((Ptr)&(doubleBuffer->dbSoundData[0]), gDBPI.inSParmBlk->ioParam.ioActCount);
	doubleBuffer->dbNumFrames = gDBPI.inSParmBlk->ioParam.ioActCount/(long)(localSI->frameSize*localSI->nChans);
 	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;

	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount) || gDBPI.nextBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
		gDBPI.lastBlock = TRUE;
	}else if(gDBPI.lastBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	}else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}

void 
SignToUnsignBlock(Ptr block, long size)
{
	long	i;
	for (i = (size >> 2) - 1; i >= 0; --i)
	{
		* (long *)block ^= 0x80808080;
		block += 4;
	}				
	for (i = (size & 3) - 1; i >= 0; --i)
		* (char *)block++ ^= 0x80;			
}

// the start of mulaw playback????
// have to adjust size of file in, size of buffer out, size of conversion
pascal void
MuDoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);

	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	Ulaw2ShortBlock((unsigned char *)(gDBPI.fileBlock), (short *)doubleBuffer->dbSoundData, gDBPI.inSParmBlk->ioParam.ioActCount);
	doubleBuffer->dbNumFrames = gDBPI.inSParmBlk->ioParam.ioActCount/(long)(localSI->frameSize*localSI->nChans);
 	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;

	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount) || gDBPI.nextBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
		gDBPI.lastBlock = TRUE;
	}else if(gDBPI.lastBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	}else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}

// have to adjust size of file in, size of buffer out, size of conversion
pascal void
ADoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);

	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	Alaw2ShortBlock((unsigned char *)(gDBPI.fileBlock), (short *)doubleBuffer->dbSoundData, gDBPI.inSParmBlk->ioParam.ioActCount);
	doubleBuffer->dbNumFrames = gDBPI.inSParmBlk->ioParam.ioActCount/(long)(localSI->frameSize*localSI->nChans);
 	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;

	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount) || gDBPI.nextBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
		gDBPI.lastBlock = TRUE;
	}else if(gDBPI.lastBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	}else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}

pascal void	ADDVIDoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);

	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	doubleBuffer->dbNumFrames = (gDBPI.inSParmBlk->ioParam.ioActCount/localSI->nChans) << 1;
	BlockADDVIDecode((unsigned char *)(gDBPI.fileBlock), (short *)doubleBuffer->dbSoundData, 
		doubleBuffer->dbNumFrames, localSI->nChans, FALSE);
 	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;

	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount) || gDBPI.nextBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
		gDBPI.lastBlock = TRUE;
	}else if(gDBPI.lastBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	}else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}


// have to adjust size of file in, size of buffer out, size of conversion
pascal void
FltDoubleBackProc(SndChannelPtr myChannel, SndDoubleBufferPtr doubleBuffer)
{
	long	theA5;
	SoundInfo	*localSI;
	OSErr	error;
	float	gain;
	static long loopInit, tmpLong, playBarInit;
	
	theA5 = SetA5(doubleBuffer->dbUserInfo[0]);
	if(playBarInit == 2)
		playBarInit--;
	else if(playBarInit == 1)
	{
		gDBPI.ticksStart = TickCount();
		playBarInit = 0;
	}
	localSI = (SoundInfo *)doubleBuffer->dbUserInfo[1];
	if(gDBPI.inSParmBlk->ioParam.ioResult != 0 && gDBPI.inSParmBlk->ioParam.ioResult != -39)
	{
	// time to fuck up playback
		doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;
		theA5 = SetA5(theA5);
		return;
	}
	
	gain = 32767.0/localSI->peak;
	Flt2ShortBlock((float *)(gDBPI.fileBlock), (short *)doubleBuffer->dbSoundData, gDBPI.inSParmBlk->ioParam.ioActCount, gain);
	doubleBuffer->dbNumFrames = gDBPI.inSParmBlk->ioParam.ioActCount/(long)(localSI->frameSize*localSI->nChans);
 	/* Mark buffer as ready */
	doubleBuffer->dbFlags = doubleBuffer->dbFlags | dbBufferReady;

	if((gDBPI.inSParmBlk->ioParam.ioActCount != gDBPI.inSParmBlk->ioParam.ioReqCount) || gDBPI.nextBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
		gDBPI.lastBlock = TRUE;
	}else if(gDBPI.lastBlock)
	{
		doubleBuffer->dbFlags = (doubleBuffer->dbFlags) | dbLastBuffer;
	}else
	{
		if(loopInit)
		{
			gDBPI.inSParmBlk->ioParam.ioPosOffset = localSI->dataStart;
			gDBPI.inSParmBlk->ioParam.ioReqCount = tmpLong;
			loopInit = FALSE;
			playBarInit = 2;
		}
		if((gDBPI.inSParmBlk->ioParam.ioPosOffset + gDBPI.inSParmBlk->ioParam.ioReqCount)
			> (localSI->dataStart + localSI->numBytes))
		{
			if(gDBPI.loop)
			{
				tmpLong = gDBPI.inSParmBlk->ioParam.ioReqCount;
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
				loopInit = TRUE;
			}
			else
			{
				gDBPI.inSParmBlk->ioParam.ioReqCount = (localSI->dataStart + localSI->numBytes) - gDBPI.inSParmBlk->ioParam.ioPosOffset;
				gDBPI.nextBlock = TRUE;
				error = PBRead(gDBPI.inSParmBlk, TRUE);
			}
		}
		else
			error = PBRead(gDBPI.inSParmBlk, TRUE);
	}
	theA5 = SetA5(theA5);
}

void Flt2ShortBlock(float *floatSams, short *shortSams, long size, float gain)
{
	long i;
	
	for(i=0; i < (size>>2); i++)
		*(short *)(shortSams + i) = *(float *)(floatSams + i) * gain;
}

