/* 
 *
 * Main.c - the realy boring stuff.
 *
 * Copyright 1995 Tom Erbe
 */
 
#if __MC68881__
#define __FASTMATH__
#define __HYBRIDMATH__
#endif	/* __MC68881__ */
#include <Gestalt.h>
#include <math.h>
#include <SoundInput.h>
#include <Timer.h>
#include "Dialog.h"
#include "Menu.h"
#include "Event.h"
#include "MyAppleEvents.h"
#include "SoundFileHeader.h"
#include "Play.h"
#include "PAPlay.h"
#include "OpenSoundFile.h"
#include "CloseSoundFile.h"
#include "Main.h"
#include "Misc.h"

#define	REMOVE_ALL_EVENTS	0

#define	LEAVE_IT_WHERE_IT_IS	FALSE
#define	NORMAL_UPDATES			TRUE
 
/* Event Related Parameters */
#define	SLEEP				0L
#define	NIL_MOUSE_REGION	0L
#define	WNE_TRAP_NUM		0x60
#define	UNIMPL_TRAP_NUM		0x9F
#define	SUSPEND_RESUME_BIT	0x0001
#define	ACTIVATING			1
#define	RESUMING			1

/* Window display parameters */
#define	DRAG_THRESHOLD		30
#define	MIN_WINDOW_HEIGHT	50
#define	MIN_WINDOW_WIDTH	50

#define	MARK_APPLICATION	1

#define	SYS_VERSION			1

/* global variables */
GlowBalls	global;

//extern DoubleBufPlayInfo	gDBPI;
extern PAPlayInfo	gPAPlayInfo;
extern MenuHandle	gAppleMenu, gFileMenu, gEditMenu, gFontMenu;

#ifdef powerc
SndDoubleBackUPP	gS8DoubleBackProc;
SndDoubleBackUPP	gSw16DoubleBackProc;
SndDoubleBackUPP	gMuDoubleBackProc;
SndDoubleBackUPP	gADoubleBackProc;
SndDoubleBackUPP	gDoubleBackProc;
SndDoubleBackUPP	gADDVIDoubleBackProc;
SndDoubleBackUPP	gFltDoubleBackProc;
FileFilterUPP		gMyFileFilter;
TimerUPP			gDoMouseTask;
AEEventHandlerUPP	gMyHandleOAPP;
AEEventHandlerUPP	gMyHandleODOC;
AEEventHandlerUPP	gMyHandlePDOC;
AEEventHandlerUPP	gMyHandleQUIT;
#endif

void
main() 
{
	ToolBoxInit();				// setup managers
	global.appFileNum = CurResFile();	// store the resource fork number
	SetUpDragRect();			// sets up the window for dragging
	SetUpSizeRect();			// and for resizing
	MenuBarInit();
	MaxApplZone();				// give us as much memory as you have
#ifdef powerc
	RoutineDesInit();			// installs powerpc callback functions
#endif
	AppleEventInit();
	GlobalInit();				// initialize global vars
	if(CapabilityCheck())		// test to see if the mac is not a mac plus
	{
//		InstallTask();
		MainLoop();				// the program
//		RemoveTask();
	}
}

void
ToolBoxInit()
{
	InitGraf(&(qd.thePort));
	InitFonts();
	FlushEvents(everyEvent, REMOVE_ALL_EVENTS);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NIL_POINTER);
	InitCursor();
}

Boolean
CapabilityCheck()
{
	OSErr	status;
	long		response;
	NumVersion	myVersion;
	
	global.soundCompress = false;
	myVersion = SndSoundManagerVersion();
	status = Gestalt(gestaltSoundAttr, &response);
	if(myVersion.majorRev >= 0x03)
	{
		if(myVersion.minorAndBugRev >= 0x20)
			global.soundCompress = true;
	}
	status = Gestalt(gestaltProcessorType, &response);
	if(response < 3L)
	{
		StopAlert(NO_FPU_ALERT, NIL_POINTER);
		return(FALSE);
	}
	
	status = Gestalt(gestaltSystemVersion, &response);
	if((status!=noErr)||(response<0x0751))
	{
		StopAlert(BAD_SYS_ALERT, NIL_POINTER);
		return(FALSE);
	}
	
	status = Gestalt(gestaltAppleEventsAttr, &response);
	if((status!=noErr)||((response&0x0001) == 0x0))
	{
		StopAlert(BAD_SYS_ALERT, NIL_POINTER);
		return(FALSE);
	}
	status = Gestalt (gestaltQuickTime, &response);
	if((status!=noErr)||(response<0x0400000))
	{
		StopAlert(BAD_SYS_ALERT, NIL_POINTER);
		return(FALSE);
	}

	status = Gestalt(gestaltFinderAttr, &response);
	if((status!=noErr)||((response&0x0008) == 0x0))
	{
		StopAlert(BAD_SYS_ALERT, NIL_POINTER);
		return(FALSE);
	}
	else
		return(TRUE);
}


#ifdef powerc
void
RoutineDesInit(void)
{
	gDoMouseTask = NewRoutineDescriptor((ProcPtr)DoMouseTask, uppTimerProcInfo, GetCurrentISA());
//	gDoubleBackProc = NewRoutineDescriptor((ProcPtr)DoubleBackProc, uppSndDoubleBackProcInfo, GetCurrentISA());
//	gS8DoubleBackProc = NewRoutineDescriptor((ProcPtr)S8DoubleBackProc, uppSndDoubleBackProcInfo, GetCurrentISA());
//	gSw16DoubleBackProc = NewRoutineDescriptor((ProcPtr)Sw16DoubleBackProc, uppSndDoubleBackProcInfo, GetCurrentISA());
//	gMuDoubleBackProc = NewRoutineDescriptor((ProcPtr)MuDoubleBackProc, uppSndDoubleBackProcInfo, GetCurrentISA());
//	gADDVIDoubleBackProc = NewRoutineDescriptor((ProcPtr)ADDVIDoubleBackProc, uppSndDoubleBackProcInfo, GetCurrentISA());
//	gFltDoubleBackProc = NewRoutineDescriptor((ProcPtr)FltDoubleBackProc, uppSndDoubleBackProcInfo, GetCurrentISA());
	gMyFileFilter = NewRoutineDescriptor((ProcPtr)MyFileFilter, uppFileFilterProcInfo, GetCurrentISA());
	gMyHandleOAPP = (AEEventHandlerUPP)NewRoutineDescriptor((ProcPtr)(&MyHandleOAPP), uppAEEventHandlerProcInfo, GetCurrentISA());
	gMyHandleODOC = (AEEventHandlerUPP)NewRoutineDescriptor((ProcPtr)(&MyHandleODOC), uppAEEventHandlerProcInfo, GetCurrentISA());
	gMyHandlePDOC = (AEEventHandlerUPP)NewRoutineDescriptor((ProcPtr)(&MyHandlePDOC), uppAEEventHandlerProcInfo, GetCurrentISA());
	gMyHandleQUIT = (AEEventHandlerUPP)NewRoutineDescriptor((ProcPtr)(&MyHandleQUIT), uppAEEventHandlerProcInfo, GetCurrentISA());
}
#endif

void
SetUpDragRect(void)
{
	global.dragRect = qd.screenBits.bounds;
	global.dragRect.left += DRAG_THRESHOLD;
	global.dragRect.right -= DRAG_THRESHOLD;
	global.dragRect.bottom -= DRAG_THRESHOLD;
}

void
SetUpSizeRect(void)
{
	global.sizeRect.top = MIN_WINDOW_HEIGHT;
	global.sizeRect.left = MIN_WINDOW_WIDTH;
	global.sizeRect.bottom = qd.screenBits.bounds.bottom - qd.screenBits.bounds.top;
	global.sizeRect.right = qd.screenBits.bounds.right - qd.screenBits.bounds.left;
}

void
GlobalInit()
{
	OSErr	error;
	Rect	windowRect, pictRect;
	unsigned long i, iItemCnt, secs;
	unsigned short fontChoice;
	// pick a random font
	iItemCnt = CountMItems(gFontMenu);
	GetDateTime(&secs);
	fontChoice = LoWord(secs);
	while(fontChoice > iItemCnt)
		fontChoice -= iItemCnt;
	if(fontChoice == 0)
		fontChoice = 1;
	HandleFontChoice(fontChoice);

	
	// Set up common variables
	global.done = FALSE;
	global.fileOpen = FALSE;
	global.paused = FALSE;
	OpenPreferences();
	
	// Pictures
	global.aboutPict = GetPicture(ABOUT_PICT);
	global.prefPict = GetPicture(PREF_PICT);
	for(i=0; i<10; i++)
		global.playPict[i] = GetPicture(131+i);
	
	// Windows
	global.errorDialog = GetNewDialog(ERROR_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	global.aboutWindow = GetNewCWindow(ABOUT_WIND,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	global.prefWindow = GetNewCWindow(PREF_WIND,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	global.wNEpresent = (NGetTrapAddress(WNE_TRAP_NUM, ToolTrap) != NGetTrapAddress(UNIMPL_TRAP_NUM, ToolTrap));

	windowRect.top = qd.screenBits.bounds.top + 33;
	windowRect.right = qd.screenBits.bounds.right - 3;
	windowRect.left = windowRect.right - 20;
	windowRect.bottom = qd.screenBits.bounds.bottom - 3;
	global.theOpenSF.playWind = NewCWindow(nil,&windowRect,"\p",false,floatProc,nil,false,8888);	
    NewGWorld(&global.playBarGW, 16, &windowRect, 0, nil, 0);
	pictRect.top = pictRect.left = 0;
	pictRect.right = pictRect.bottom = 64;
	
    //Set up our spirte gWorld
    error = NewGWorld(&global.spriteGW, 16, &pictRect, 0, nil, 0);
    
	// preset things for quick soundfile playback
//	gDBPI.channel = 0L;
//	gDBPI.doubleHeader.dbhBufferPtr[0] = (SndDoubleBufferPtr)NewPtrClear(sizeof(SndDoubleBuffer) + (long)(MAX_SIZE_BLOCK * 4));
//	gDBPI.doubleHeader.dbhBufferPtr[1] = (SndDoubleBufferPtr)NewPtrClear(sizeof(SndDoubleBuffer) + (long)(MAX_SIZE_BLOCK * 4));
//	if(gDBPI.doubleHeader.dbhBufferPtr[0] == nil || gDBPI.doubleHeader.dbhBufferPtr[1] == nil || MemError() != 0)
//    {
 //   	DrawErrorMessage("\pNo Memory");
//		global.done = TRUE;
 //   }
		
//	error = SndNewChannel(&gDBPI.channel, sampledSynth, 0, nil);
//	if(error != 0)
//	{
//		DrawErrorMessage("\pError Allocating Sound Channel");
//		global.done = TRUE;
//	}	
//	gDBPI.fileBlock = (char *)NewPtr((long)(MAX_SIZE_BLOCK * 4));
	InitializePlay();
	global.theOpenSF.peak = 1.0;
}

void
MainLoop()
{
	while(global.done == FALSE)
		HandleEvent();
}

void
HandleEvent()
{
	char	theChar;
	
	NullEventTasks();
	if(global.wNEpresent)
	WaitNextEvent(everyEvent, &global.theEvent, SLEEP, NIL_MOUSE_REGION);
	else
	{
		SystemTask();
		GetNextEvent(everyEvent, &global.theEvent);
	}
	
	switch(global.theEvent.what)
	{
		case nullEvent:
			NullEventTasks();
			break;
		case kHighLevelEvent :
			AEProcessAppleEvent(&global.theEvent);			
			break;
		case mouseDown:
			HandleMouseDown();
			break;
		case keyDown:
		case autoKey:
			theChar = global.theEvent.message & charCodeMask;
			if (( global.theEvent.modifiers & cmdKey) != 0)
				HandleMenuChoice(MenuKey(theChar));
			break;
		case updateEvt:
			BeginUpdate((WindowPtr)global.theEvent.message);
			EndUpdate((WindowPtr)global.theEvent.message);
			break;
		default:
			break;
	}
}

void
HandleMouseDown()
{
	WindowPtr	whichWindow;
	short		thePart;
	long		menuChoice, windSize;
	GrafPtr		oldPort;
	
	thePart = FindWindow(global.theEvent.where, &whichWindow);
	switch(thePart)
	{
		case inMenuBar:
			menuChoice = MenuSelect(global.theEvent.where);
			HandleMenuChoice(menuChoice); // handle all menu choices
			break;
		case inSysWindow:
			SystemClick(&global.theEvent,whichWindow);
			break;
		case inDrag:
			DragWindow(whichWindow,global.theEvent.where,&global.dragRect);
			break;
		case inGoAway:
			HideWindow(whichWindow);
			break;
		case inGrow:
			windSize = GrowWindow(whichWindow,global.theEvent.where,&global.sizeRect);
			if (windSize != 0)
			{
				GetPort(&oldPort);
				SetPort(whichWindow);
				EraseRect(&whichWindow->portRect);
				SizeWindow(whichWindow,LoWord(windSize),HiWord(windSize),NORMAL_UPDATES);
				InvalRect(&whichWindow->portRect);
				SetPort(oldPort);
			}
			break;
		case inContent:
			if(whichWindow == global.theOpenSF.playWind)
				HandlePlayClick(whichWindow);
			else
				SelectWindow(whichWindow);
			break;
		case inZoomIn:
		case inZoomOut:
			if (TrackBox(whichWindow,global.theEvent.where,thePart))
			{
				GetPort(&oldPort);
				SetPort(whichWindow);				
				EraseRect(&whichWindow->portRect);
				ZoomWindow(whichWindow,thePart,LEAVE_IT_WHERE_IT_IS);
				InvalRect(&whichWindow->portRect);
				SetPort(oldPort);
			}
			break;
	}
}

void	OpenPreferences(void)
{
	short	sysVRefNum, rRefNum;
	long	prefDirID;
	FSSpec	prefFSS;
	Handle	playHandle, loopHandle, keyHandle, blockHandle;
   	ProcessSerialNumber		psn;
	ProcessInfoRec			theProc;
	FSSpec					procSpec;
	Str31					prefStr, processName;

	FindFolder(kOnSystemDisk, 'pref', kDontCreateFolder, &sysVRefNum, &prefDirID);
	// initialize the process information record
	theProc.processInfoLength = sizeof(ProcessInfoRec);
	theProc.processName = (StringPtr)&processName;
	theProc.processAppSpec = &procSpec;
	
	GetCurrentProcess(&psn);
	GetProcessInformation(&psn, &theProc);
	
	StringAppend(theProc.processName, "\p Pref", prefStr);
	FSMakeFSSpec(sysVRefNum, prefDirID, prefStr, &prefFSS);
	// Open file to check for existence, then close for ReadSettings, which opens it
	// again.
	rRefNum = FSpOpenResFile(&prefFSS, fsCurPerm);
	if(rRefNum != -1)
	{
		CloseResFile(rRefNum);
		FlushVol((StringPtr)nil, prefFSS.vRefNum);
		rRefNum = FSpOpenResFile(&prefFSS,fsCurPerm);
		UseResFile(rRefNum);
		// playHandle, loopHandle, keyHandle, blockHandle;
		playHandle = GetNamedResource('STR ',"\pfinder playback");
		if(playHandle == nil)
			global.finderPlay = TRUE;
		else
		{
			HLock(playHandle);
			if(EqualString((StringPtr)*playHandle,"\poff",TRUE,TRUE)) 
				global.finderPlay = FALSE;
			else
				global.finderPlay = TRUE;
			HUnlock(playHandle);
		}
		
		loopHandle = GetNamedResource('STR ',"\plooping");
		if(loopHandle == nil)
			SetPlayLooping(false);
		else
		{
			HLock(loopHandle);
			if(EqualString((StringPtr)*loopHandle,"\pon",TRUE,TRUE)) 
				SetPlayLooping(true);
			else
				SetPlayLooping(false);
			HUnlock(loopHandle);
		}
		
		keyHandle = GetNamedResource('STR ',"\phot key");
		if(keyHandle == nil)
		{
			global.hotKey = optionKey;
			global.coldKey = controlKey;
		}
		else
		{
			HLock(keyHandle);
			if(EqualString((StringPtr)*keyHandle,"\pcontrol",TRUE,TRUE)) 
			{
				global.hotKey = controlKey;
				global.coldKey = optionKey;
			}
			else
			{
				global.hotKey = optionKey;
				global.coldKey = controlKey;
			}
			HUnlock(keyHandle);
		}
		
		blockHandle = GetNamedResource('STR ',"\pblock size");
		if(blockHandle == nil)
			gPAPlayInfo.framesPerRead = 24576L;
		else
		{
			HLock(blockHandle);
			StringToNum((StringPtr)*blockHandle, &gPAPlayInfo.framesPerRead);
			HUnlock(blockHandle);
			if(gPAPlayInfo.framesPerRead != 4096L && gPAPlayInfo.framesPerRead != 8192L && gPAPlayInfo.framesPerRead != 12288L && 
				gPAPlayInfo.framesPerRead != 16384L && gPAPlayInfo.framesPerRead != 20480L && gPAPlayInfo.framesPerRead != 24576L)
				gPAPlayInfo.framesPerRead = 24576L;
		}				
		CloseResFile(rRefNum);
		UseResFile(global.appFileNum);
		FlushVol((StringPtr)nil, prefFSS.vRefNum);
	}
	else
		// No preferences file, get defaults from internal settings
	{
		global.finderPlay = TRUE;
		global.hotKey = optionKey;
		global.coldKey = controlKey;
		SetPlayLooping(false);
		gPAPlayInfo.framesPerRead = 24576L;
	}
}

void	SavePreferences(void)
{
	short	sysVRefNum, rRefNum;
	long	prefDirID;
	FSSpec	prefFSS;
	Str255	tmpString;
	Handle	playHandle, loopHandle, keyHandle, blockHandle;
	short	rID;
   	ProcessSerialNumber		psn;
	ProcessInfoRec			theProc;
	FSSpec					procSpec;
	Str31					prefStr, processName;

	FindFolder(kOnSystemDisk, 'pref', kDontCreateFolder, &sysVRefNum, &prefDirID);
	// initialize the process information record
	theProc.processInfoLength = sizeof(ProcessInfoRec);
	theProc.processName = (StringPtr)&processName;
	theProc.processAppSpec = &procSpec;
	
	GetCurrentProcess(&psn);
	GetProcessInformation(&psn, &theProc);
	
	StringAppend(theProc.processName, "\p Pref", prefStr);
	FSMakeFSSpec(sysVRefNum, prefDirID, prefStr, &prefFSS);
	rRefNum = FSpOpenResFile(&prefFSS, fsCurPerm);
	if(rRefNum != -1)
	{
		CloseResFile(rRefNum);
		FlushVol((StringPtr)nil, prefFSS.vRefNum);
		FSpDelete(&prefFSS);
		FlushVol((StringPtr)nil, prefFSS.vRefNum);
	}
	FSpCreateResFile(&prefFSS, 'N6P_', 'pref' , smSystemScript);
	rRefNum = FSpOpenResFile(&prefFSS,fsCurPerm);
	UseResFile(rRefNum);

//		global.finderPlay = TRUE;
	if(global.finderPlay)
		StringCopy("\pon", tmpString);
	else
		StringCopy("\poff", tmpString);
	PtrToHand(tmpString, &playHandle, 32);
	rID = UniqueID('STR ');
	AddResource(playHandle, 'STR ', rID, "\pfinder playback");
//		gDBPI.loop = FALSE;
	if(GetPlayLooping())
		StringCopy("\pon", tmpString);
	else
		StringCopy("\poff", tmpString);
	PtrToHand(tmpString, &loopHandle, 32);
	rID = UniqueID('STR ');
	AddResource(loopHandle, 'STR ', rID, "\plooping");
//		global.hotKey = optionKey;
	if(global.hotKey == optionKey)
		StringCopy("\poption", tmpString);
	else
		StringCopy("\pcontrol", tmpString);
	PtrToHand(tmpString, &keyHandle, 32);
	rID = UniqueID('STR ');
	AddResource(keyHandle, 'STR ', rID, "\phot key");
//		gPAPlayInfo.framesPerRead = 24576L;
	NumToString(gPAPlayInfo.framesPerRead, tmpString);
	PtrToHand(tmpString, &blockHandle, 32);
	rID = UniqueID('STR ');
	AddResource(blockHandle, 'STR ', rID, "\pblock size");
	
	CloseResFile(rRefNum);
	UseResFile(global.appFileNum);
	FlushVol((StringPtr)nil, prefFSS.vRefNum);
}

void TerminateInstantPlayer(void)
{
	if(GetPlayState())
		StopPlay(false);
	if(global.fileOpen)
		CloseSoundFile(&global.theOpenSF);
	global.done = TRUE;
	SavePreferences();
	TerminatePlay();
}