/*
 * SimpApp.h - defines, typedefs and prototypes for SimpApp.
 */

/*
 * File Manager Defines.
 */
#define	NIL_POINTER		0L
#define	NIL_STRING		"\p"
#define	IGNORED_STRING	NIL_STRING
#define	NIL_FILE_FILTER	NIL_POINTER
#define	NIL_DIALOG_HOOK	NIL_POINTER
#define NOTE_WIND			128
#define ABOUT_WIND			129
#define ABOUT_PICT			129
#define PREF_WIND			130
#define PREF_PICT			130

#define	MOVE_TO_FRONT		-1L
#define FUNCTIONSIZE		400L

#define ON					1
#define OFF					0

#define	STEREO				2
#define	MONO				1

#define	NO_PROCESS			0
#define PLAY_PROCESS		1
#define EVENT_PROCESS		2


/*
 * Function prototypes
 */
void 	SetUpDragRect(void);
void	SetUpSizeRect(void);
void	RoutineDesInit(void);
void	main();
void	ToolBoxInit();
Boolean	CapabilityCheck();
void	DialogInit();
void	GlobalInit();
void	MainLoop();
void	HandleEvent();
void	HandleMouseDown();
void	OpenPreferences(void);
void	SavePreferences(void);
void	TerminateInstantPlayer(void);

typedef struct
{
	short		hotKey;
	short		coldKey;
	short		appFileNum;
	short		fontNum;
	Boolean		done;
	Boolean		fileOpen;
	Boolean		finderPlay;
	Boolean		playActive;
	Boolean		paused;
	Boolean		eventActive;
	Boolean		fontChanged;
	Boolean		wNEpresent;
	Boolean		soundCompress;
	DialogPtr	errorDialog;
	EventRecord	theEvent;
	GWorldPtr	playBarGW;
	GWorldPtr	spriteGW;
	PicHandle 	aboutPict;
	PicHandle 	prefPict;
	PicHandle 	playPict[10];
	Rect		dragRect;
	Rect		sizeRect;
	WindowPtr 	aboutWindow;
	WindowPtr 	prefWindow;
	SoundInfo	theOpenSF;
	BitMap		txtBitMap;
}	GlowBalls;


