/*
 *	SoundHack
 *	Copyright 1994 Tom Erbe
 *
 *  SANE MUST BE REMOVED TO DO ANYTHING ON THE POWER PC!!!!!!
 *
 *	Misc.c - Various string manipulation hacks for pascal style strings. Also, all of soundhack's
 *	SANE functions used to live here. These functions have been rewritten to use the ANSI math 
 *	and stdio routines instead.
 *
 *	Functions:
 *	LLog2()			a log2 function from ANSI functions.
 *	EExp2()			an exp2 function from ANSI functions.
 *	StringCopy()	Copies one pascal string to another.
 *	StringAppend()	Takes two input strings, concatenates them, puts the result into
 *					an output string.
 *	FixToString()	Like NumToString, but for floating point numbers. Creates a string
 *					with 6 digits to the right of the decimal.
 *	StringToFix()	The reverse.
 *	ZeroFloatTable()	This just clears a floating point array.
 */
#if __MC68881__
#define __FASTMATH__
#define __HYBRIDMATH__
#endif	/* __MC68881__ */
#include <math.h>

#include <stdio.h>
#include "SoundFile.h"
#include <AppleEvents.h>
#include "Misc.h"
OSErr
TouchFolder( short vRefNum , long parID )
{
	CInfoPBRec rec ;
	Str63 name ;
	short err ;

    rec.hFileInfo.ioNamePtr = name ;
    name [ 0 ] = 0 ;
    rec.hFileInfo.ioVRefNum = vRefNum ;
    rec.hFileInfo.ioDirID = parID ;
    rec.hFileInfo.ioFDirIndex = -1 ;
    rec.hFileInfo.ioFVersNum = 0 ;
    err = PBGetCatInfoSync ( & rec ) ;
    if ( err ) {
        return err ;
    }
    GetDateTime ( & rec.dirInfo.ioDrMdDat ) ;
    rec.hFileInfo.ioVRefNum = vRefNum ;
    rec.hFileInfo.ioDirID = parID ;
    rec.hFileInfo.ioFDirIndex = -1 ;
    rec.hFileInfo.ioFVersNum = 0 ;
    rec.hFileInfo.ioNamePtr [ 0 ] = 0 ;
    err = PBSetCatInfoSync ( & rec ) ;
    return err ;
}

double
LLog2(double x)
{
	double ret;
	
	ret = log10(x) / log10(2.0);
	return(ret);
}

double
EExp2(double x)
{
	double ret;

	ret = pow(2.0, x);
	return(ret);
}

void
StringCopy(Str255 stringIn, Str255 stringOut)
{
	short i;
	for(i = 0; i <= stringIn[0]; i++)
		stringOut[i] = stringIn[i];
}

void
StringAppend(Str255 stringHead, Str255 stringTail, Str255 stringOut)
{
	short i;
	
	stringOut[0] = stringHead[0] + stringTail[0];
	for(i = 1; i <= stringHead[0]; i++)
		stringOut[i] = stringHead[i];
	for(i = 1; i <= stringTail[0]; i++)
		stringOut[i+stringHead[0]] = stringTail[i];
}

void	
StringToFix(Str255 s, double *f)
{
	PtoCstr(s);
	sscanf((char *)s, "%Lf", f);
	CtoPstr((char *)s);
}

void
FixToString(double f, Str255 s)
{	
	short error;
	error = sprintf((char *)s, "%7.6Lf", f);
	CtoPstr((char *)s);
}

void
FixToString3(double f, Str255 s)
{	
	short error;
	error = sprintf((char *)s, "%4.3Lf", f);
	CtoPstr((char *)s);
}

void
FixToString12(double f, Str255 s)
{
	sprintf((char *)s, "%12.6Lf", f);
	CtoPstr((char *)s);
}

void
ZeroFloatTable(float A[], long n)
{
	long i;
	
	for(i=0; i<n; i++)
		A[i] = 0.0;
}

void
RemovePtr(Ptr killMePtr)
{
	if(killMePtr != nil)
		DisposePtr(killMePtr);
}


short RangedRdm(short min, short max )
/* assume that min is less than max */
{
	long	qdRdm;	/* treat return value as 0-65536 */
	long	range, t;

	qdRdm = Random()+32768;
	range = max - min;
	t = (qdRdm * range) / 65536; 	/* now 0 <= t <= range */
	return( t+min );
}

